iv.myanim=function(wnd,node,info)
{
    iv.anim.node.call(this,wnd,node,info);
    this.window=wnd;
}
iv.myanim.prototype=new iv.anim.node();

iv.myanim.prototype.detach=function(wnd,f)
{
    if(iv.anim.node.prototype.detach) iv.anim.node.prototype.detach.call(this,wnd,f);
    this.window.uiShowPlayButton(false);
    this.window.ui.animPlaying=null;
}

iv.window.prototype.show=function(a,show)
{
    if(!show)show=""
    a.div.style.display=show;
}

iv.window.prototype.uiShowPlayButton=function(show)
{
    var ui=this.ui;
    var a,b;
    if(show){a="none";b="";}
    else {b="none";a="";}
    //ui.btnPlayForward.style.display=a;
    this.show(ui.btnPlayForward,a);
    this.show(ui.btnPlayBackward,a);
    
    this.show(ui.btnPause,b);
}

iv.window.prototype.uiToggleAnimation=function(mode)
{
    this.uiHidePane(this.ui.animsPane);
    var r=null,s=this.space,ui=this.ui,info;
	if(s){

        if(!mode)
        {
            this.removeAnimation(ui.animPlaying);
        }else
        {
            if(mode==1)
            {
                var info={from:ui.trackbar.timeCurrent,to:ui.trackbar.timeMax};
                if((info.from-info.to)>=-0.03)info.from=ui.trackbar.timeMin;
            }else
            {
                var info={from:ui.trackbar.timeCurrent,to:ui.trackbar.timeMin};
                if((info.from-info.to)<=-0.03)info.from=ui.trackbar.timeMax;
            }

            r=new iv.myanim(this,ui.trackbar,info);
            this.addAnimation(r);
            ui.animPlaying=r;
            this.uiShowPlayButton(true);  

        }
	}
}

iv.window.prototype.uiUpdateLayout=function()
{
    var v=this.viewport;
    var ui=this.ui;
    var xTrack=0;

//treeview    
    var h=ui.divFrame.clientHeight;
{$if _TREEVIEW_}
    if(ui.treePane && ui.leftVisible)
    {
        var _h=h-8;
        ui.treePane.style.height=''+h+'px';
        
        ui.treeView.div.style['min-height']=''+_h+'px';
        ui.treeView.div.style.width=""+ui.treeDivider.value+"px";
    
        ui.treeFrame.style.top="36px";
        ui.treeFrame.style.height=''+_h+'px';
        ui.treeDivider.imp.xdiv.style.height=''+(h)+'px';
        var s=ui.treePane.style;
        s.top="0px";
        xTrack=ui.treeDivider.value+33;
    }
{$endif}
    var d=ui.trackbar;
    if(d)
        d.setSize(ui.playDivider.value,32);

    if(ui.activePane)
    {
        var d=ui.activePane;
        var s=d.style;
        //d.style.bottom="54px";

        if(d==ui.animsPane){
            
            s.bottom="50px";
            
            var rect=ui.btnAnimations.div.getBoundingClientRect();
            var rectF=ui.divFrame.getBoundingClientRect();
            var delta=rect.left-rectF.left;

            var rm=d.getBoundingClientRect();// rect menu
            var max=rectF.width-5;
            if((rm.width+delta)>max)
                delta=max-rm.width;

            s.left=""+delta+"px";
            
        }
{$if _BUTTON_CONFIG_}
        if(d==ui.toolsPane){
            s.right="50px";
            s.top="10px";
            }
{$endif}
{$if _BUTTON_VIEW_}
        if(d==ui.viewPane){
            s.right="50px";
            s.top="10px";
            }       
{$endif}
    }
};


iv.window.prototype.checkDivSize=function(force)
{
    var ui=this.ui;
    var w=ui.divFrame.clientWidth;
    var h=ui.divFrame.clientHeight;
    var u=this.viewport;
    if((u.x!=w) || (u.y!=h)|| force){
        this.setViewSize(w,h);
        this.uiUpdateLayout();
    }
};

iv.window.prototype.onFullScreen=function()
{
    var ui=this.ui;
    this.uiHidePane();
    var btn=ui.btnFS;
    this.checkDivSize();
    if (document.fullscreenElement==ui.divFrame)
    {   
        btn.svg0.style.display='none';
        btn.svg1.style.display='block';
    }else
    {
        btn.svg1.style.display='none';
        btn.svg0.style.display='block';
    }
}

iv.window.prototype.uiSwitchFullScreen=function()
{
    var d=this.ui.divFrame,D=document;
    if (D.fullscreenElement || D.msFullscreenElement) {
        if (D.exitFullscreen)
            D.exitFullscreen();
        else
        if (D.msExitFullscreen)
            D.msExitFullscreen();        
      } else {
        if(d.requestFullscreen)
            d.requestFullscreen();
            else
        if(d.msRequestFullscreen)
            d.msRequestFullscreen()
      }
};

iv.window.prototype.uiCreateElement=function(n,p)
{
    var div=document.createElement('div');
    div.className=n;
    if(p)p.appendChild(div);
    return div;
}
{$if _TREEVIEW_}
iv.window.prototype.uiSwitchTreeView=function()
{
    var ui=this.ui;
    var update=true;
    if(!ui.treePane)
    {
        var _this=this;
        var div=this.uiCreateElement('ivleftbar',ui.divFrame);
        ui.treePane=div;
        var divf=this.uiCreateElement("ivtreeframe",div);
        var divt=this.uiCreateElement('tree-view',divf);
        ui.treeFrame=divf;

        divt.style.width="200px";
        ui.treeView=new iv.treeView(divt,this);
        var divdiv=this.uiCreateElement("vdivider",div);

        ui.treeDivider=new iv.vdivider(divdiv);
        ui.treeDivider.value=200;
        ui.treeDivider.min=100;
        ui.treeDivider.max=600;

        ui.treeDivider.onValueChanged=function()
        {
            _this.uiUpdateLayout();
        }
        ui.leftVisible=true;
        this.uiUpdateLayout();
        ui.leftVisible=false;
        update=false;
    }
    var s=ui.treePane.style;
    
    if(!ui.leftVisible){
        s.left="0px";
        ui.leftVisible=true;
    }
    else {s.left="-"+(ui.treeDivider.value+20)+"px";ui.leftVisible=false;}
    if(update)this.uiUpdateLayout();
}
{$endif}
iv.window.prototype.uiAddSeparator=function(div)
{
    var d=document.createElement('hr');
    div.appendChild(d);
}

iv.window.prototype.uiAddCheckBox=function(div,data)
{
    var cdiv=this.uiCreateElement("ivcheckbox",div);

    //var d=document.createElement('div');
    var d=this.uiCreateSVG(cdiv,{path:iv.icons.check,width:16,height:16});
    if(!data.checked)
    {
        d.style.visibility="hidden";
    }

    
    var info={div:cdiv,check:d,checked:data.checked||false};
    if(data.id!==undefined)info.id=data.id;

    d=document.createElement('span');
    
    d.innerHTML=data.text.replace(' ','&nbsp;');
    cdiv.appendChild(d);
    info.text=d;

    if(data.func){
        var f=function(e){data.func(info,e)}
        cdiv.onclick=f;
        cdiv.ondblclick=f;
    }

    return info;
}
iv.window.prototype.uiSetCheckBox=function(i,chk)
{
    i.check.style.visibility=chk?"visible":"hidden";
    i.checked=chk;
}

{$if _BUTTON_CONFIG_}
iv.window.prototype.uiToggleCheckBox=function(i)
{
    this.uiSetCheckBox(i,!i.checked);
    return i.checked;
}
iv.window.prototype.uiUpdateRMode=function()
{
    var space=this.space,mode=space.rmodes[space.cfgRMode].name,_i=this.ui.rmodes;
    for(var i=0;i<_i.length;i++)
    {
        var a=_i[i];
        this.uiSetCheckBox(a,a.id==mode);
    }
}
iv.window.prototype.uiAddRenderModes=function()
{
    var space=this.space,ui=this.ui,mode=space.rmodes[space.cfgRMode];
    mode=mode?mode.name:"";
    var _this=this,setRMode=function(i){_this.setRMode(i.id);_this.uiUpdateRMode();}
    var rmodes=["Solid","Wireframe","Shaded Wireframe","Hidden Wireframe","Outline","Ilustration"],rids=["solid","wire","wireshaded","hiddenwire","outline","illustration"];
    var _i=ui.rmodes=[];
    for(var i=0;i<rmodes.length;i++)_i.push(this.uiAddCheckBox(ui.toolsPane,{text:rmodes[i],id:rids[i],func:setRMode}));
    this.uiUpdateRMode();
};
iv.window.prototype.uiSwitchConfig=function()
{
    var ui=this.ui;
    if(this.uiHidePane(ui.toolsPane))return;
    if(!ui.toolsPane)
    {
        var space=this.space;
        var div=document.createElement('div');
        div.className="ivxbar";
        ui.toolsPane=div;
        var _this=this;
        
        ui.cfgTextures=this.uiAddCheckBox(div,{text:"Textures",checked:this.getTextures(),func:function()    {_this.setTextures(_this.uiToggleCheckBox(ui.cfgTextures))}});
        ui.cfgMaterials=this.uiAddCheckBox(div,{text:"Materials",checked:this.getMaterials(),func:function(){_this.setMaterials(_this.uiToggleCheckBox(ui.cfgMaterials))}});
        ui.cfgDblSide=this.uiAddCheckBox(div,{text:"Backfacing Polygons",checked:this.getDoubleSided(),func:function(){_this.setDoubleSided(_this.uiToggleCheckBox(ui.cfgDblSide))}});
{$if _SHADOW_}
        ui.cfgShadows=this.uiAddCheckBox(div,{text:"Shadows",checked:this.getShadows(),func:function(){_this.setShadows(_this.uiToggleCheckBox(ui.cfgShadows))}});
{$endif}
        this.uiAddSeparator(div);
        this.uiAddLightModes();

        this.uiAddSeparator(div);
        this.uiAddRenderModes();
        ui.divFrame.appendChild(div);
    }
    this.uiShowPane(ui.toolsPane);
}
iv.window.prototype.uiAddLightModes=function()
{
    var space=this.space,ui=this.ui,_this=this;
    ui.lightModes=[];
    var names=["Light From File","White Lights","Day Lights","Blue Lights","Hard","No Lights"];
    var setLights=function(i){_this.uiSetLights(i.id);}
    for(var i=0;i<names.length;i++){
        ui.lightModes.push(this.uiAddCheckBox(ui.toolsPane,{text:names[i],id:i,func:setLights}));
    }
    this.updateLightsMenu(0);
}

iv.window.prototype.uiSetLights=function(id)
{
  var l=null;
  switch(id)
  {
        case 0:l=null;break;
        case 1:l=[{"color":[0.38,0.38,0.45],"dir":[-0.784465,-0.588348,-0.196116],"type":1},{"color":[0.6,0.6,0.67],"dir":[0.590796,0.324938,-0.738495],"type":1},{"color":[0.5,0.5,0.57],"dir":[-0.242536,0,0.970143],"type":1}];break;
        case 2:l=[{"color":[0.5,0.5,0.5],"dir":[-0.784465,-0.588348,-0.196116],"type":1},{"color":[0.8,0.8,0.9],"dir":[0.590796,0.324938,-0.738495],"type":1},{"color":[0.9,0.9,0.9],"dir":[0.00999937,0.00499969,0.999938],"type":1}];break;
        case 3:l=[{"color":[0.4,0.4,0.7],"dir":[-0.784465,-0.588348,-0.196116],"type":1},{"color":[0.75,0.75,0.95],"dir":[0.590796,0.324938,-0.738495],"type":1},{"color":[0.7,0.7,0.95],"dir":[0,0,1],"type":1}];break;//blue
        case 4:l=[{"color":[0.5,0.5,0.5],"dir":[-0.57735,-0.57735,-0.57735],"type":1},{"color":[0.8,0.8,0.9],"dir":[0.57735,0.57735,-0.57735],"type":1},{"color":[0.9,0.9,0.9],"dir":[-0.242536,0,0.970143],"type":1}];break;
        case 5:l=[];
  }
   this.setLights(l);
   this.updateLightsMenu(id);
}

iv.window.prototype.updateLightsMenu=function(id)
{
    var ui=this.ui,_i=ui.lightModes;
    for(var i=0;i<_i.length;i++)this.uiSetCheckBox(_i[i],i==id);    
}
{$endif}


iv.window.prototype.uiSwitchAnimations=function()
{
    var ui=this.ui;
    this.uiShowHint(ui.btnAnimations,false);
    if(this.uiHidePane(ui.animsPane))return;
    if(!ui.animsPane)
    {
        var space=this.space,div=ui.animsPane=this.uiCreateElement("ivxbar",ui.divFrame),_this=this,_i=space.anims,_j=ui.animations=[],i;
        ui.animsPane.id="Animations";
        
        var func=function(f)
        {
            if(ui.animPlaying)_this.removeAnimation(ui.animPlaying);
            _this.space.activateAnimation(f.id,true);
            ui.trackbar.setAnimation(_this.space);
            if(f.id.time!==undefined){
                space.setTime(f.id.time);
            }
            _this.invalidate(iv.INV_VERSION|iv.INV_STRUCTURE);
            _this.uiUpdateAnimationName();
            for(i=0;i<ui.animations.length;i++)
            {
                var A=ui.animations[i];
                _this.uiSetCheckBox(A,A==f);
            }
        };
        
        for(i=0;i<_i.length;i++)
        {
            var a=_i[i];
            _j.push(this.uiAddCheckBox(div,{id:a,text:this.uiGetAnimName(a),checked:a==this.space.anim,func:func}));
        }
    }
    this.uiShowPane(ui.animsPane);
}

{$if _BUTTON_VIEW_}
iv.window.prototype.uiSwitchView=function()
{   
    var ui=this.ui;
    if(this.uiHidePane(ui.viewPane))return;
    if(!ui.viewPane)
    {
        var div=document.createElement('div');
        div.className="ivxbar";
        ui.viewPane=div;
        var _this=this;
        ui.btnOrtho=this.uiAddCheckBox(div,{text:"Ortho",id:"ortho",checked:false,func:function(){_this.setOrtho(true);_this.uiUpdateViewsMenu();}  });
        ui.btnPerspective=this.uiAddCheckBox(div,{text:"Perspective",id:"perspective",checked:false,func:function(){_this.setOrtho(false);_this.uiUpdateViewsMenu();}  });

        this.uiAddSeparator(div);
        var _i=[],names=["Left","Right","Top","Bottom","Front","Back"],func=function(i){_this.setStdView(i.id)}
        for(var i=0;i<names.length;i++)
        {
            var n=names[i];
            var nl=n.toLowerCase();
            _i.push(this.uiAddCheckBox(div,{text:n,id:nl,checked:false,func:func}) );
        }
        ui.stdViews=_i;
        this.uiAddSeparator(div);
        _i.push(this.uiAddCheckBox(div,{text:"Home",id:"home",checked:false,func:function(){_this.setDefView(iv.VIEW_TRANSITION)}  }) );
        _i.push(this.uiAddCheckBox(div,{text:"Zoom to Fit",id:"home",checked:false,func:function(){_this.zoomToFit(null,iv.VIEW_TRANSITION|iv.VIEW_VISIBLE)}}) );
        ui.divFrame.appendChild(div);
    }    
    this.uiUpdateViewsMenu();
    this.uiShowPane(ui.viewPane);
}


iv.window.prototype.getStdViewName=function()
{
	var _i=iv.stdViews;
	var v=this.getView();
	var dir=v.getViewVectorN(),up=v.getUpVector();
	vec3.normalize(up);
	vec3.scale(dir,-1);
	var epsilon=1e-5;
	var _up;
	for(var i in _i)
	{
		var V=_i[i];
		 _up=vec3.subtract(V.u,V.f,[]);
		if(vec3.compare(_up,up,epsilon)&&
		   vec3.compare(V.f,dir,epsilon))
		   return i;
	}
	return "user";
}

iv.window.prototype.uiUpdateViewsMenu=function()
{
    var name=this.getStdViewName();
    var ui=this.ui;
    var _i=ui.stdViews;
    for(var i=0;i<_i.length;i++)
    {
        var I=_i[i];
        this.uiSetCheckBox(I,name==I.id);
    }    
    var o=this.isOrtho();
    this.uiSetCheckBox(ui.btnOrtho,o);
    this.uiSetCheckBox(ui.btnPerspective,!o);

};
{$endif}
iv.window.prototype.uiHidePane=function(d)
{
    var rez=false;
    //if(d)
    {
    var ui=this.ui;
    var div=ui.activePane;
    if(div)
    {
        if(d==div)rez=true;
        var s=div.style;
        s.display="none";
{$if _BUTTON_CONFIG_}
        if(div==ui.toolsPane)this.uiShowHint(ui.btnCfg,true);
{$endif}
{$if _BUTTON_VIEW_}
        if(div==ui.viewPane)this.uiShowHint(ui.btnView,true);
{$endif}
    }
    ui.activePane=null;
    }
    return rez;
}
iv.window.prototype.uiShowPane=function(div)
{
    var s=div.style;
    var ui=this.ui;
    s.display="block";
    ui.activePane=div;
{$if _BUTTON_CONFIG_}
    if(ui.activePane==ui.toolsPane)this.uiShowHint(ui.btnCfg,false);
{$endif}
{$if _BUTTON_VIEW_}
    if(ui.activePane==ui.viewPane)this.uiShowHint(ui.btnView,false);
{$endif}
    this.uiUpdateLayout();
}

iv.window.prototype.uiOnCommand=function(btn)
{
    switch(btn.id)
    {
        case "ivfullscreen":this.uiSwitchFullScreen();break;
{$if _TREEVIEW_}
        case "ivtreeview":this.uiSwitchTreeView();break;
{$endif}
{$if _BUTTON_CONFIG_}
        case "ivconfig":this.uiSwitchConfig();break;
{$endif}
{$if _BUTTON_VIEW_}
        case "ivview":this.uiSwitchView();break;
{$endif}
    }
}
iv.window.prototype.uiCreateSVG=function(parent,i)
{
    var ns="http://www.w3.org/2000/svg";
    var svg=document.createElementNS(ns,"svg");
    svg.setAttribute("width",""+(i.width?i.width:24)+"px");
    svg.setAttribute("height",""+(i.height?i.height:24)+"px");
    var path=document.createElementNS(ns,"path");
    svg.appendChild(path);
    if(parent)parent.appendChild(svg);
    path.setAttribute('d',i.path);
    return svg;
}

iv.window.prototype.uiCreateButton=function(i)
{
    var div=this.uiCreateElement(i.path?"ivbutton":"ivtextbutton",i.parent),info={div:div};
    if(i.func)div.onclick=i.func;
    if(i.path){
        info.svg=this.uiCreateSVG(div,i);
    }
    if(i.id)div.id=i.id;
    if(i.hint)
    {
        var span=this.uiCreateElement("tooltiptext",div);
        span.innerHTML=i.hint;
        info.hint=span;
        info.hintVisible=true;
    }
    return info;
}

iv.delayedClose=function(w)
{
    this.type="delayedClose";
    this.wnd=w;
    this.time=0;
}
iv.delayedClose.prototype.animate=function(k)
{
    this.time+=k;
    if(this.time>1000)
    {
        var ui=this.wnd.ui;
        if(ui.playdiv)ui.playdiv.style.opacity=0;
        ui.rightbar.style.opacity=0;
        return 0;
    }
    return 1;
}

iv.window.prototype._divMouseMove=function(event,show)
{
    //console.log("show ",show);
    var ui=this.ui;
    var a=this.getAnimation("delayedClose");
    if(a<0)a=null;else a=this.transitions[a];
    if(show)
    {
        if(ui.playdiv)ui.playdiv.style.opacity=1;
        ui.rightbar.style.opacity=1;
        if(a)this.removeAnimation(a);
    }else
    {
        if(!ui.activePane && !ui.leftVisible)
        {
            if(a)a.time=0;
            else
                this.addAnimation(new iv.delayedClose(this));
        }
    }
}
iv.icons={
{$if _TREEVIEW_}
tree:"M19,17L5,17L5,19L19,19L19,17ZM19,11L5,11L5,13L19,13L19,11ZM19,5L5,5L5,7L19,7L19,5Z",
{$endif}
{$if _BUTTON_CONFIG_}
cfg:"M14.209,6.664L13.711,6.515L13.313,4.125L10.687,4.125L10.29,6.511C9.957,6.616 9.638,6.747 9.328,6.909L7.359,5.503L5.503,7.359L6.912,9.33L6.664,9.79L6.515,10.289L4.125,10.687L4.125,13.312L6.511,13.71C6.615,14.043 6.747,14.362 6.909,14.672L5.503,16.641L7.359,18.497L9.33,17.088L9.789,17.335L10.289,17.486L10.687,19.875L13.312,19.875L13.71,17.489C14.043,17.385 14.362,17.253 14.671,17.091L16.639,18.497L18.496,16.641L17.087,14.67L17.334,14.211L17.484,13.711L19.875,13.313L19.875,10.687L17.489,10.29C17.385,9.957 17.253,9.638 17.091,9.329L18.497,7.361L16.641,5.504L14.67,6.913L14.209,6.664ZM15.494,12C15.494,13.93 13.928,15.494 12,15.494C10.07,15.494 8.506,13.928 8.506,12C8.506,10.072 10.07,8.506 12,8.506C13.93,8.506 15.494,10.07 15.494,12Z",
{$endif}
{$if _BUTTON_VIEW_}
view:"M12.016,6.394C14.099,6.394 15.818,7.088 17.276,7.903C18.573,8.628 19.51,9.494 20.241,10.314C20.572,10.684 20.832,10.964 21.058,11.294C21.205,11.51 21.403,11.706 21.403,12.006C21.403,12.214 21.331,12.368 21.218,12.532C21.036,12.797 20.819,13.057 20.609,13.305C20.294,13.676 19.975,14.04 19.541,14.422C18.873,15.011 18.203,15.617 17.222,16.178C15.766,17.011 14.012,17.618 12.016,17.618C9.204,17.618 6.789,16.264 5.072,14.912C4.545,14.497 4.08,14.027 3.695,13.579C3.083,12.867 2.649,12.456 2.652,12.006C2.655,11.534 3.144,11.114 3.674,10.5C4.081,10.028 4.528,9.566 4.951,9.216C5.994,8.352 7.224,7.516 8.734,6.976C9.703,6.63 10.783,6.394 12.016,6.394ZM11.997,7.442C14.511,7.442 16.552,9.483 16.552,11.997C16.552,14.51 14.511,16.551 11.997,16.551C9.483,16.551 7.443,14.51 7.443,11.997C7.443,9.483 9.483,7.442 11.997,7.442ZM12.005,9.634C13.312,9.634 14.373,10.695 14.373,12.002C14.373,13.309 13.312,14.37 12.005,14.37C10.698,14.37 9.637,13.309 9.637,12.002C9.637,10.695 10.698,9.634 12.005,9.634Z",
{$endif}
pf:"M6,5L18,12L6,19L6,5Z",
pb:"M18,5L6,12L18,19L18,5Z",
pp:"M22,5L19,5L19,19L22,19L22,5ZM29,5L26,5L26,19L29,19L29,5Z",
check:"M13.03,5.53L6.5,12.06L2.97,8.53L4.03,7.47L6.5,9.94L11.97,4.47L13.03,5.53Z",
fsA:"M10,19L5,19L5,14L7,14L7,17L10,17L10,19ZM14,19L19,19L19,14L17,14L17,17L14,17L14,19ZM14,5L19,5L19,10L17,10L17,7L14,7L14,5ZM10,5L5,5L5,10L7,10L7,7L10,7L10,5Z",
fsB:"M5,14L10,14L10,19L8,19L8,16L5,16L5,14ZM19,14L14,14L14,19L16,19L16,16L19,16L19,14ZM19,10L14,10L14,5L16,5L16,8L19,8L19,10ZM5,10L10,10L10,5L8,5L8,8L5,8L5,10Z"

};

iv.window.prototype.uiShowHint=function(b,show)
{
    if(b.hintVisible!=show)
    {
        b.hintVisible=show;
        if(show)b.div.appendChild(b.hint);
        else b.hint.remove();
    }
}
iv.window.prototype.uiMakeControls=function(div)
{
    var _this=this;
    var ui=this.ui;
    var s=this.space;
    if(!ui.rightbar){
    this.setEvent(document,"fullscreenchange",function(){_this.onFullScreen()});
    this.setEvent(div,"mousemove",function(event){_this._divMouseMove(event,true)});
    this.setEvent(div,"mouseleave",function(event){_this._divMouseMove(event,false)});
    var _func=function(a){_this.uiOnCommand(this)};

    var rbar=this.uiCreateElement("ivrightbar",div);
    var A=ui.btnFS=this.uiCreateButton({parent:rbar,func:_func,id:"ivfullscreen",path:iv.icons.fsA,hint:"Toggle Full Screen"});
    A.svg0=A.svg;
    A.svg1=this.uiCreateSVG(A.div,{path:iv.icons.fsB});
    A.svg1.style.display='none';
{$if _TREEVIEW_}
    ui.btnTree=this.uiCreateButton({parent:rbar,func:_func,id:"ivtreeview",path:iv.icons.tree,hint:"Show Objects"});
{$endif}
{$if _BUTTON_VIEW_}
    ui.btnView=this.uiCreateButton({parent:rbar,func:_func,id:"ivview",path:iv.icons.view,hint:"View"});
{$endif}
{$if _BUTTON_CONFIG_}
    ui.btnCfg=this.uiCreateButton({parent:rbar,func:_func,id:"ivconfig",path:iv.icons.cfg,hint:"Show Options"});
{$endif}
    ui.rightbar=rbar;
    function outputsize() {
        _this.checkDivSize();        
    }
    if(window.ResizeObserver)
        new ResizeObserver(outputsize).observe(div);
      else  setInterval(outputsize,100);
    }

    if(s.anim && !ui.playdiv)
    {
        var bar=this.uiCreateElement("ivplaybar",div);
        ui.playdiv=bar;
        ui.btnPlayBackward=this.uiCreateButton({parent:bar,func:function(){_this.uiToggleAnimation(2);},path:iv.icons.pb});
        ui.btnPlayForward=this.uiCreateButton({parent:bar,func:function(){_this.uiToggleAnimation(1);},path:iv.icons.pf});
        ui.btnPause=this.uiCreateButton({parent:bar,func:function(){_this.uiToggleAnimation(0);},path:iv.icons.pp,width:48});
        ui.btnPause.div.style.display='none';
        
        //if(this.space.anims && (this.space.anims.length>1))// replace 0 to 1
        {
            ui.btnAnimations=A=this.uiCreateButton({parent:bar,func:function(){_this.uiSwitchAnimations();},id:"ivanims",hint:"Select Animation"});
            var txt=document.createElement("span");
            A.div.appendChild(txt);
            ui.btnAnimationsText=txt;
            this.uiUpdateAnimationName();
        }

        var divdiv=this.uiCreateElement("vdivider",bar);
        var d=ui.playDivider=new iv.vdivider(divdiv);
        d.min=50;
        d.max=500;
        d.value=500;// 100 was the default
        d.reverse=true;
        var canvas=document.createElement("canvas");
        canvas.id="trackbar";
        var t=ui.trackbar=new iv.trackbar(canvas);
        
        d.onValueChanged=function(a){t.setSize(a.value,t.h);}
        bar.appendChild(canvas);
    }
    
    if(ui.playdiv){
        
        ui.trackbar.setAnimation(s);
        ui.playdiv.style.visibility=s.anim?"visible":"hidden";
        ui.btnAnimations.div.style.display=(s.anims && (s.anims.length>1))?"block":"none";
    }
    
    
    _this.uiUpdateLayout();

}

iv.window.prototype.uiGetAnimName=function(a)
{
    if(a.name&&a.name.length)return a.name;
    var i=iv.indexOf(this.space.anims);
    return "Animation"+i;
}

iv.window.prototype.uiUpdateAnimationName=function()
{
    var a=this.space.anim;
    var span=this.ui.btnAnimationsText;
    span.innerHTML=(a.name&&a.name.length)?a.name:this.uiGetAnimName(a);
}


iv.initViewer=function(info)
{
     var div=null;
    var canvas=document.createElement("canvas");
    canvas.style.border='none';
    
    var _info={};
    for (var v in info)
    {
        var d=info[v];
        switch(v)
        {
            case 'div':div=d;break;
            case 'width':canvas.width=d;break;
            case 'height':canvas.height=d;break;

            default:_info[v]=d;
        }
    }
    if(div){
    canvas.width=div.clientWidth;
    canvas.height=div.clientHeight;
    _info.canvas=canvas;
    div.appendChild(canvas);
    _info.callback=function(event)
    {
        if(event){
        var v=event.wnd;
        switch(event.code)
        {
            case "dataReady":v.uiMakeControls(div);break;
            case "mousedown":v.uiHidePane();v._divMouseMove(null,true);break;
            case "animend":{
                if((event.type=='spin' || event.type=='view')&&v.ui.stdViews)
                    v.uiUpdateViewsMenu();
            }break;
        }}
    }
    v=new iv.window(_info);
    v.ui={divFrame:div};
{$if _LOADPROGRESS_}
    new iv.progressIndicator(v,{size:100,color:{$_TEXTCOLOR_},animation:false});
{$endif}
{$if _WORLD_AXIS_}
    new iv.axis3d(v,{file:"viewaxis.iv3d",path:"res/",pos:1,size:130});
{$endif}
    return v;
    }
    return null;
}


/*TRACKBAR*/
iv.trackbar=function(canvas)
{
    iv.wnd.call(this,canvas);
    this.initHandlers();
    this.w=this.h=0;
    this.timer=false;
    this.context=canvas.getContext('2d');
    this.margin=16;
    this.timeMin=0;
    this.timeMax=0;
    this.timeCurrent=0;
}
iv.trackbar.prototype=new iv.wnd();
iv.trackbar.prototype.setSize=function(w,h)
{
    if((this.w!=w)||(this.h!=h))
    {
    this.w=w;
    this.h=h;
    var c=this.div();
    c.width=w;
    c.height=h;

    c.style.width=""+w+"px";
	c.style.height=""+h+"px";
    this.invalidate();
   }
}

iv.trackbar.prototype.setAnimation=function(space){
    var a=space.anim;
    this.space=space;
    if(a)
    {
        this.timeMin=a.start;
        this.timeMax=a.end;
        this.timeCurrent=a.time;
    }else
    {
        this.timeMin=0;
        this.timeMax=0;
    }
    this.invalidate();
}

iv.trackbar.prototype.setTime=function(t)
{
    var rez=0;
    if(this.space){
        t=Math.min(Math.max(t,this.timeMin),this.timeMax);
        if(this.timeCurrent!=t)
            {
                this.space.anim.time=t;
                this.timeCurrent=t;
                this.invalidate();
            }
        rez=this.space.setTime(t);
    }
    return rez;
}
iv.trackbar.prototype.repaint=function()
{
    var ctx=this.context;
    ctx.clearRect(0,0,this.w,this.h);

    if(this.timeMax>this.timeMin)
    {
        var x0=this.timeToX(this.timeMin);
        var x1=this.timeToX(this.timeMax);
        var xm=this.timeToX(this.timeCurrent);

        ctx.fillStyle="rgba(0,0,0,0.25)";
        var y=this.h/2-2;
        var width=2;
        ctx.fillRect(x0,y,x1-x0,width);
        var color="#000000";
        if(xm>x0){
            ctx.fillStyle=color;
            ctx.fillRect(x0,y,xm-x0,width);
        }
        var color="#ffffff";
        ctx.beginPath();
        var radius=5.5;
        ctx.arc(xm,y+width/2, radius, 0, 2 * Math.PI, false);
        ctx.fillStyle = color;
        ctx.fill();
        ctx.lineWidth = 2;
        ctx.strokeStyle = '#000000';
        ctx.stroke();
    }

    this.timer=false;
}

iv.trackbar.prototype.timeToX=function(time)
{
    var d=this.timeMax-this.timeMin;
    if(d)
    {
        var k=(time-this.timeMin)/d;
        return this.margin+k*(this.w-this.margin*2);
    }else return this.margin;
}

iv.trackbar.prototype.xtoTime=function(x)
{
    x-=this.margin;
    var d=this.timeMax-this.timeMin;
    if(d)
    {
        var k=x/(this.w-this.margin*2);
        k=Math.min(Math.max(k,0),1);
        var t=d*k+this.timeMin;
        
        return t;
    }
    return null;
}

iv.trackbar.prototype.setTimeX=function(x)
{
    var t=this.xtoTime(x);
    if(t!==null)
    {
        this.space.setTime(t);
        this.timeCurrent=t;
        this.invalidate();
        this.space.invalidate(iv.INV_VERSION|iv.INV_STRUCTURE);
    }
}

iv.trackbar.prototype.invalidate=function()
{
    if(this.timer)return ;
	this.timer=true;
    window.setTimeout(this.repaint.bind(this),1000/60);
}
iv.trackbar.prototype.onMouseDown=function(event,touch) {
	event=this.getLocalPnt(event,touch);if(!event)return;
	this.setCapture();
    this.setTimeX(event.x);
}
iv.trackbar.prototype.onMouseUp=function(event) {
	this.releaseCapture();
}
iv.trackbar.prototype.onMouseMove=function(event,p,touches,b) {
	if(b) {
		this.setTimeX(p.x);
        iv.pdsp(event);
	} else this.releaseCapture();
}



