var view3d;
var ivtoolbar;

function UndoMgr_UpdateButtons()
{
var name;
   if(this.m_undo_btn){
   var name=this.getLastUndoDescription();
	if(name)this.m_undo_btn.title="Undo: "+name;
   else this.m_undo_btn.title="Nothing to Undo";
 }
   if(this.m_redo_btn){
    name=this.getLastRedoDescription();
  if(name)this.m_redo_btn.title="Redo: "+name;
   else this.m_redo_btn.title="Nothing to Redo";
}
}


iv.window.prototype.getHandler=function(b,event)
{
    var m=this.cfgEditorMode;
   if(this.space){
	if(event.type=="mousedown"){

	if(m &&  this.space.selNode)
    switch(m)
	{
		case "move":return new iv.objMoveHandler(this);
		case "rotate":return new iv.objRotateHandler(this);
		case "scale":return new iv.objScaleHandler(this);
	}
	}
	}
	return null;
}

iv.initEditor3d=function(file,color)
{
  var cnv=document.getElementById("ivwindow3d");
  ivtoolbar=document.getElementById("toolbar");
  
  var v=new iv.window({canvas:cnv,file:file,color:color});
  
  v.treeDivider=new iv.vdivider(document.getElementById("main.divider"));
  v.treeDivider.value=Math.max(Math.round(document.body.clientWidth/6),200);
  v.treeDivider.onValueChanged=function(){iv.resizeCanvas(v);};

window.onresize = function(){iv.resizeCanvas(v);} 

  {$if _LOADPROGRESS_}new iv.progressIndicator(v,{size:100,color:{$_TEXTCOLOR_},animation:false});{$endif}
  {$if _WORLD_AXIS_}new iv.axis3d(v,{file:"viewaxis.iv3d",path:"res/",pos:3,size:130});{$endif}
  v.addRefTarget(function(event)
  {
    switch(event.code)
    {
        case "dataReady":
            {
            if(v.space.anim){
                var btn=document.getElementById("ivanimate");
                if(btn)btn.style.visibility="visible";
            }
    	    iv.updateButtons(v);
            var mode=v.space.rmodes[v.space.cfgRMode];
            iv.updateButtonsRM(mode?mode.name:"");
            }break;
        case "selection":
{$if _NODE_GIZMO_}
		// modify list, by removing non supported items
		v.updateTransformGizmo(event.current,event.node);
{$endif}
{$if _METAVIEW_}
			if(event.wnd.metaView)event.wnd.metaView.onNodeSelected(event.node);
{$endif}
			break;
    }
  });

  v.m_undo=new iv.undo.manager(v);
  v.m_undovp=v.m_undo;
  v.m_undo.updateButtons=UndoMgr_UpdateButtons;
  v.m_undo.m_undo_btn=document.getElementById("view3d-undo");
  v.m_undo.m_redo_btn=document.getElementById("view3d-redo");
  v.m_undo.updateButtons();
  view3d=v;
  ivCheckButton("view3d-obj-select","view3d-obj-select");

    var objects=document.getElementById("treeview");
    v.treeView=new iv.treeView(objects,v);    

{$if _METAVIEW_}
    objects=document.getElementById("metaview");
    if(objects)v.metaView=new iv.metaView(objects,v);
{$endif}
  iv.resizeCanvas(v);

  return v;
}


function ivCheckButton(id,_id)
{
	var a=" tb-active";
	var btn=document.getElementById(id);// should we use toolbar?
	if(btn)
	{
		if(id==_id){
			if(btn.className.indexOf(a)<0)
				btn.className+= a;
			}
				else
			btn.className=btn.className.replace(a,"");
	}
}

function ivSetCheck(id,check)
{
	var a=" tb-active";
	var btn=document.getElementById(id);// should we use toolbar?
	if(btn)
	{
		if(check){
			if(btn.className.indexOf(a)<0)
				btn.className+= a;
			}
				else
			btn.className=btn.className.replace(a,"");
	}
}
function ivToggleButton(id)
{
	var btn=document.getElementById(id);// should we use toolbar?
	if(btn){
	var a=" tb-active";
		if(btn.className.indexOf(a)<0){
				btn.className+= a;
				return true;
				}
		else
				btn.className=btn.className.replace(a,"");
	}
	return false;
}
function ivShowFileInfo()
{

}


function ivSetVPMode(id)
{
	var _id="view3d-"+id;
	ivCheckButton("view3d-rotate",_id);
	ivCheckButton("view3d-zoom",_id);
	ivCheckButton("view3d-pan",_id);
if(id=="rotate")view3d.cfgButtons[0]=1;else
if(id=="zoom")view3d.cfgButtons[0]=2;else
if(id=="pan")view3d.cfgButtons[0]=4;
}
iv.setEditMode=function(id)
{
	var _id="view3d-obj-"+id;
	ivCheckButton("view3d-obj-select",_id);
	ivCheckButton("view3d-obj-move",_id);
	ivCheckButton("view3d-obj-rotate",_id);
	ivCheckButton("view3d-obj-scale",_id);
	view3d.cfgEditorMode=id;
{$if _NODE_GIZMO_}
	view3d.updateTransformGizmo2();
{$endif}
}

iv.setAxis=function(id)
{
 var _id="view3d-axis-"+id;
 var chk=ivToggleButton(_id);
 var iaxis=0;
 if(id=="x")iaxis=1;else
 if(id=="y")iaxis=2;else
 if(id=="z")iaxis=4;
 if(chk)view3d.cfgEditorAxis|=iaxis;else view3d.cfgEditorAxis&= ~iaxis;
{$if _NODE_GIZMO_}
	view3d.updateTransformGizmo2();
{$endif}
}

iv.updateButtons=function(v)
{
var axis=v.cfgEditorAxis;
ivSetCheck("view3d-axis-x",axis&1);
ivSetCheck("view3d-axis-y",axis&2);
ivSetCheck("view3d-axis-z",axis&4);
var mode=v.cfgButtons[0];;
var id="";
if(mode==1)id="view3d-rotate";else
if(mode==2)id="view3d-zoom";else
if(mode==3)id="view3d-pan"
ivSetCheck(id,true);
id=""

id="view3d-obj-"+v.cfgEditorMode;

ivSetCheck(id,true);
iv.setCheckMenu("view3d-cfg-textures",v.getTextures());
iv.setCheckMenu("view3d-cfg-dblside",v.getDoubleSided());
iv.setCheckMenu("view3d-cfg-materials",v.getMaterials());
iv.updateButtonsLights("view3d-lights-world");
}

function ivDoUndo()
{
	view3d.m_undo.undo();
}
function ivDoRedo()
{
	view3d.m_undo.redo();
}
iv.setCheckMenu=function(id,bSet)
{
	var btn=document.getElementById(id);
	var objs = btn.getElementsByTagName("div");
	if(objs && objs.length)
	{
		var img=objs[0];
		var atrr=bSet?"visible":"hidden";
		if(img.style.visibility!=atrr)
			img.style.visibility=atrr;
	}
}
iv.toggleTextures=function()
{
	var b=!view3d.getTextures();
	view3d.setTextures(b);
	iv.setCheckMenu("view3d-cfg-textures",b);
}
iv.toggleTree=function()
{
	var t=document.getElementById("treeview-frame");  
	var d=view3d.treeDivider.div.style;
	if(t.style.display=="none")
	{
		iv.setCheckMenu("view3d-cfg-tree",true);
		t.style.display="";
		d.display="";
	}else
	{
		iv.setCheckMenu("view3d-cfg-tree",false);
		t.style.display="none";
		d.display="none";
	}
	iv.resizeCanvas(view3d);
}
{$if _SHADOW_}
iv.toggleShadows=function()
{
	var b=!view3d.getShadows();
	view3d.setShadows(b);
	iv.setCheckMenu("view3d-cfg-shadows",b);
}
{$endif}
iv.toggleDoubleSided=function()
{
	var b=!view3d.getDoubleSided();
	view3d.setDoubleSided(b);
	iv.setCheckMenu("view3d-cfg-dblside",b);
}
iv.toggleMaterials=function()
{
	var b=!view3d.getMaterials();
	view3d.setMaterials(b); 
	iv.setCheckMenu("view3d-cfg-materials",b);
}
iv.setCheckMenu2=function(name,name2)
{
  iv.setCheckMenu(name,name==name2);
};

iv.updateButtonsLights=function(id)
{
  iv.setCheckMenu2("view3d-lights-world",id);
  iv.setCheckMenu2("view3d-lights-off",id);
  iv.setCheckMenu2("view3d-lights-hard",id);
  iv.setCheckMenu2("view3d-lights-white",id);
  iv.setCheckMenu2("view3d-lights-day",id);
  iv.setCheckMenu2("view3d-lights-blue",id);
}

iv.updateButtonsRM=function(id)
{
var rms=["solid","wire","hiddenwire","illustration","wireshaded","outline"];
var a='view3d-rm-';
id=a+id;
 for(var i=0;i<rms.length;i++)
 {
   var b=a+rms[i];
   iv.setCheckMenu2(b,id);
 }
}


iv.setRMode=function(menu)
{
  var id=menu.id;
  var _id=id.substring(10,id.length);
  view3d.setRMode(_id);
  iv.updateButtonsRM(_id);
}
iv.setLights=function(menu)
{
var id=0;
if(menu){
  var id=menu.id;
  var l=null;
  if(id=="view3d-lights-world")l=null;
  else
  if(id=="view3d-lights-off")l=[];
  else
  if(id=="view3d-lights-hard")  l=[{"color":[0.5,0.5,0.5],"dir":[-0.57735,-0.57735,-0.57735],"type":1},{"color":[0.8,0.8,0.9],"dir":[0.57735,0.57735,-0.57735],"type":1},{"color":[0.9,0.9,0.9],"dir":[-0.242536,0,0.970143],"type":1}];
    else
  if(id=="view3d-lights-blue") l=[{"color":[0.4,0.4,0.7],"dir":[-0.784465,-0.588348,-0.196116],"type":1},{"color":[0.75,0.75,0.95],"dir":[0.590796,0.324938,-0.738495],"type":1},{"color":[0.7,0.7,0.95],"dir":[0,0,1],"type":1}];
    else
  if(id=="view3d-lights-day") l=[{"color":[0.5,0.5,0.5],"dir":[-0.784465,-0.588348,-0.196116],"type":1},{"color":[0.8,0.8,0.9],"dir":[0.590796,0.324938,-0.738495],"type":1},{"color":[0.9,0.9,0.9],"dir":[0.00999937,0.00499969,0.999938],"type":1}];
  else
  if(id=="view3d-lights-white")l=[{"color":[0.38,0.38,0.45],"dir":[-0.784465,-0.588348,-0.196116],"type":1},{"color":[0.6,0.6,0.67],"dir":[0.590796,0.324938,-0.738495],"type":1},{"color":[0.5,0.5,0.57],"dir":[-0.242536,0,0.970143],"type":1}];
  
   view3d.setLights(l);
  }
  iv.updateButtonsLights(id);
}
function ivPlayAnimation()
{
	view3d.playAnimation();
}


iv.resizeCanvas=function(view)
{
{$if _BOTTOM_PART_}
  var height=500;
{$else}
  var height=window.innerHeight;
  var r=view.imp.xdiv.getBoundingClientRect();
  height-=r.y;

{$endif}
  var width = document.body.clientWidth;
  var tree=document.getElementById("treeview-frame");
  var strH=""+height+"px";
  var wtree=0,wdiv=0;
  if(tree && tree.style.display!="none")
   {

  var div=null;
  wtree=300;
  
  if(view.treeDivider)
  {
    div=view.treeDivider.imp.xdiv;
    var r=div.getBoundingClientRect();
    wdiv=r.width;
    wtree=view.treeDivider.value;
    //w+=wdiv/2;
  }
   
   tree.style.height=strH;
   if(div)div.style.height=strH;
   }

{$if _METAVIEW_}
  var meta=document.getElementById("metaview");
  if(meta && meta.style.display!="none")
   {
	var rt=meta.getBoundingClientRect();
	width-=rt.width;
	//meta.style.height=height.toString()+'px';
   }
{$endif}
  width-=wdiv;
  width--;
  width-=wtree;
  if(view.viewport.x<width)
  {    
    tree.style.width=""+wtree+"px";
    view.setViewSize(width,height);
  }else{
    view.setViewSize(width,height);
    tree.style.width=""+wtree+"px";
  }
}

