/*FULL SCREEN VIEWER*/

iv.onResize=function(v)
 {
 
  var width = window.innerWidth;
  var height=window.innerHeight;
  var e = window.devicePixelRatio || 1;   
  v.setViewSize(width,height,width*e,height*e);
  
  iv.udpateMenu(v);
}

iv.initViewer3d=function(file,bk,path,size)
{
  var canvas=document.getElementById("ivwindow3d");

  var v=new iv.window({canvas:canvas,color:bk});
  iv.uiScale=size;
  v.treeView=new iv.treeView(iv.getSubElementById(panel,"tree"),v,16*iv.uiScale);
{$if _LOADPROGRESS_}new iv.progressIndicator(v,{size:100,color:{$_TEXTCOLOR_},animation:false});{$endif}
  v.treeDivider=new iv.vdivider(iv.getSubElementById(panel,"main.divider"));
  v.treeDivider.value={$calc 300*_UISCALE_};
  v.treeDivider.onValueChanged=function()
  {
    var a="animatable",i,item,items=document.getElementsByClassName(a);
    
    if(items)
    {
      var _items=[];
      for(i=0;i<items.length;i++)_items.push(items[i]);
      items=_items;
      for(i=0;i<items.length;i++)
      {
        item=items[i];
        if (item.classList.contains(a))
        item.classList.remove(a);
      }
    }
    iv.udpateMenu(v);
    if(items && !v._restoreTransition)v._restoreTransition=items;
  };
  v.rmodes=[//render modes
	{"f":true,"n":true,"e":false,"mtl":null},//solid mode
	{"f":false,"n":true,"e":true,"mtl":null},//wireframe
    ];

  v.addRefTarget(function(a)
	{

	  switch(a.code)
	{
	case "loadError":
	if(!v.noMoreErrors){
	  v.noMoreErrors=true;
	  var str="Can't load "+a.url;
	  if(a.url.substr(0,7)=='file://')str+="\nUse web server";
	  alert(str);
	}break;
	case "dataReady":
			v.fillTree();
			var panel=document.getElementById("panel.main");
			if(v.menuOpen)iv.menuOpen=true;
			if(v.cfgSelZOffset)v.space.cfgSelZOffset=true;
                        iv.updateButtonsRM();
{$if _METAVIEW_}
    var objects=document.getElementById("metaview");
    if(objects && !v.metaView)v.metaView=new iv.metaView(objects,v);
{$endif}
			iv.udpateMenu(v);
                        break;
    case "selection":{
{$if _METAVIEW_}if(a.wnd.metaView)a.wnd.metaView.onNodeSelected(a.node);{$endif}
		break;
	}

	}});

  iv.onResize(v);
  v.load(file||"tree.iv3d",path);
  {$if _WORLD_AXIS_}new iv.axis3d(v,{file:"viewaxis.iv3d",path:"res/",pos:3,size:130});{$endif}
  window.onresize=function(){iv.onResize(v)};return v; 
}

iv.window.prototype.onCommand=function(id,extra)
{
    switch(id)
    {
	case "cm_object":this.space.select(extra,true,false);break;
        case "cm_solid":this.setRenderMode(0);break;
        case "cm_wire":this.setRenderMode(1);break;
        case "cm_left":this.setStdView("left",iv.VIEW_TRANSITION);break;
        case "cm_right":this.setStdView("right",iv.VIEW_TRANSITION);break;
        case "cm_front":this.setStdView("front",iv.VIEW_TRANSITION);break;
        case "cm_back":this.setStdView("back",iv.VIEW_TRANSITION);break;
        case "cm_bottom":this.setStdView("bottom",iv.VIEW_TRANSITION);break;
        case "cm_top":this.setStdView("top",iv.VIEW_TRANSITION);break;

        case "cm_home":this.setDefView(iv.VIEW_TRANSITION);break;
        case "cm_fit":this.zoomToFit(null,iv.VIEW_TRANSITION|iv.VIEW_VISIBLE);break;
        case "cm_view":this.setModelView(extra);break;
        case "cm_cam":
        if(extra)
        {
	var n=extra;
        var c=n.camera;
        var wtm=n.getWTM();
        var d={from:c.from.slice(),to:c.to.slice(),up:c.up.slice()};
        if(wtm)
        {
            mat4.mulPoint(wtm,d.from);
            mat4.mulPoint(wtm,d.to);
            mat4.mulPoint(wtm,d.up);
        }
	    if(c.fov)d.fov=c.fov;else d.fov=this.fov;
        this.setView(d,iv.VIEW_TRANSITION);
                       }break;
    }
};

iv.window.prototype.fillTree=function()
{
    var panel=document.getElementById("panel"),
    views=iv.getSubElementById(panel,"views"),w=this,
    s=w.space,_i=s?s.views:null,i,mv=[],
    addItem=function(name,id,extra)
    {
    	var li=document.createElement("li");
        li.innerHTML=name;
   	li.id=id;
        li.onclick=function(event)
        {
           w.onCommand(id,extra);
        };
     views.appendChild(li);
    },enumCameras=function(n,d)
    {
        if(n.camera)
        {
            var name=n.name;
            if(!name)name="Camera";
            d.addItem(name,"cm_cam",n);
        }
        n=n.firstChild;
        while(n)
        {
            enumCameras(n,d);
            n=n.next;
        }
    };
    iv.clearDIV(views);
    if(_i)for(i=0;i<_i.length;i++)mv.push(_i[i]);    
     var addItem2=function(name,id){
     var N=name.toUpperCase(),i;
     for(i=0;i<mv.length;i++)
	{
	if(N==mv[i].name.toUpperCase())
	{
	 addItem(name,"cm_view",mv[i]);
	 mv.splice(i,1);
	return;
	}
	}
	addItem(name,id);
   };

    addItem2("Left","cm_left");
    addItem2("Right","cm_right");
    addItem2("Top","cm_top");
    addItem2("Bottom","cm_bottom");
    addItem2("Front","cm_front");
    addItem2("Back","cm_back");
    
    if(s)
    {
        var d={v:mv,addItem:addItem,sep:true};
        for(i=0;i<mv.length;i++)
           {
               var v=mv[i],name=v.name;
               if(!name)name="View "+(i+1);
               addItem(name,"cm_view",v);
           } 
        enumCameras(s.root,d);
    }
    addItem("Home","cm_home");
    addItem("Fit All","cm_fit");
}
iv.window.prototype.getRenderMode=function()
{
    var n=this.space.root;
    if(n)
    {
        var mode=n.state&0xff00;
        mode>>=8;
        return mode;
    }
    return 0;
}
iv.window.prototype.setRenderMode=function(mode)
{
    if(!this.mtlWireframe){
        this.modeWireframe=  this.space.rmodes.length;
        var m=this.space.newMaterial();
        this.mtlWireframe=m;
        m.load({ diffuse: { color: 0x303030 },specular: { color: 0x808080 },emissive: { color: 0x0 } ,opacity: { amount: 0.5 }});
        this.space.rmodes.push({"f":false,"n":false,"e":true,"mtl":m});   
    }
    var n=this.space.root;
    if(n){
    n.state&=~0xff00;
    if(mode)
        n.state|=(this.modeWireframe<<8);
    this.invalidate(); 
    }
}

iv.getSubElementById=function( dNode, id ) {
	var dResult = null;
	if ( dNode.getAttribute('id') == id )
		return dNode;
	for ( var i = 0; i < dNode.childNodes.length; i++ ) {
		if ( dNode.childNodes[i].nodeType == 1 ) {
			dResult = iv.getSubElementById( dNode.childNodes[i], id );
			if ( dResult != null )
				break;
		}
	}
	return dResult;
}


iv.menuOpen=false;
iv.udpateMenu=function(v)
{
  var scale=iv.uiScale;
  var sp=function(item,x,y)
{
  if(typeof item==="string")item=document.getElementById(item);
  if(item)
  {
     if(x!==undefined)item.style.left=""+x+"px";
     if(y!==undefined)item.style.top=""+y+"px";
  }
}
  var panel=document.getElementById("panel");
  var content=document.getElementById("content");
{$if renderModesControl}
  var buttons=document.getElementById("buttons");
{$endif}
  var views=document.getElementById("views");
  var viewsRect=views.getBoundingClientRect();
  var cntRect=content.getBoundingClientRect();
  var div=null;
  var w=300*scale;
  var wdiv=0;
  if(v.treeDivider)
  {
    div=v.treeDivider.imp.xdiv;
    wdiv=10*scale;
    w=v.treeDivider.value;
    w+=wdiv/2;
  }
  var offset=20;
  var textPos=offset;
  sp(content,0,50*scale);
  panel.style.height="100%";
  if(div)div.style.height="100%";
  panel.style.width=""+w+"px";
  tree.style["min-height"]=''+cntRect.height-(viewsRect.height+32*scale)+'px';
  content.style.width=""+(w-wdiv)+"px";
{$if renderModesControl}  buttons.style.width=""+(w-10)*scale+"px";{$endif}
{$if _TREEVIEW_SEARCH_}
  var search=document.getElementById("main.search");
  if(search)search.value="";
  search.style.width=""+w-70*scale+'px';//scale?
{$endif}
  if(iv.menuOpen)
  {
     sp("main.button",w-offset-15*scale,offset);
{$if _TREEVIEW_SEARCH_}
     if(search){
     sp("main.text",offset-w,textPos);
     sp(search,offset,textPos);}else 
{$endif}
     sp("main.text",offset,textPos);
     sp(panel,0,0);
     
  }else
  {
     sp("main.button",offset,offset);
     sp("main.text",offset+30,textPos);
{$if _TREEVIEW_SEARCH_}
     if(search)sp(search,offset-w,textPos);
{$endif}
     sp(panel,-(w*1.1),0);
{$if _TREEVIEW_SEARCH_}
     if(window.view3d && view3d.treeView)view3d.treeView.search(null);
{$endif}
  }
}
{$if _TREEVIEW_SEARCH_}
iv.doSearch=function(text)
{
  if(view3d.treeView)
  {
    if(text && text.length)
    {
      text=text.toUpperCase();
      var f=function(n)
      {
        if(n.name.length)
        {
          if (n.name.toUpperCase().indexOf(text) > -1) return true;
        }
        if(n.meta)
        {
          for(var v in n.meta)
          {
            if (v.toUpperCase().indexOf(text) > -1) return true;
            var value=n.meta[v];
            if(typeof value ==='string')
            {
              if (value.toUpperCase().indexOf(text) > -1) return true;
            }else
            if(value.toString)
            {
              value =value.toString();
              if (value.toUpperCase()==text) return true;
            }
          }
        }
        return false;
      };
      view3d.treeView.search(f);
    }else view3d.treeView.search(null);
  }
}
/* MS Edge stuff - handle close search button*/
iv.doPostSearch=function(input)
{
  var old=input.value;
  setTimeout(
      function()
        {
          if(input.value!=old)
            iv.doSearch(input.value);
        },10
    );
}
{$endif}
iv.updateButtonsRM=function()
{
var s=view3d.space;
if(!s)return;
var rms=s.rmodes;
 for(var i=0;i<rms.length;i++)
 {
     var b='view3d-rm-'+rms[i].name;
     var button=document.getElementById(b);
    if(button)button.className=(i===s.cfgRMode)?'active':'passive';
 }
}

iv.setRMode=function(menu)
{
  var id=menu.id;
  var _id=id.substring(10,id.length);
  view3d.setRMode(_id);
  iv.updateButtonsRM(_id);
}
iv.toggleMenu=function(event)
{
  if(event.srcElement.type=='text')
  {
    return;
  }
  if(view3d._restoreTransition)
    {
      var items=view3d._restoreTransition;
      for(i=0;i<items.length;i++)
        items[i].classList.add("animatable");
        view3d._restoreTransition=null;
    }
  iv.menuOpen=!iv.menuOpen;
  iv.udpateMenu(view3d);
};
